import { o as f } from "./index.104c9c16.mjs";
import { computed as d, resolveComponent as m, openBlock as l, createElementBlock as s, normalizeClass as y, createElementVNode as h, withKeys as V, withModifiers as w, renderSlot as r, createTextVNode as v, toDisplayString as c, Fragment as k, renderList as g, withDirectives as p, vModelText as x, createBlock as _, createVNode as O, Transition as C, withCtx as S, createCommentVNode as B, vShow as N } from "vue";
import { _ as T } from "./_plugin-vue_export-helper.e9cbb45e.mjs";
import "./index.673e51a0.mjs";
const j = {
  provide() {
    return {
      value: d(() => this.value),
      multiple: d(() => this.multiple),
      searchable: d(() => this.searchable),
      searchValue: d(() => this.search),
      visibleOptions: d(() => this.visibleOptions)
    };
  },
  props: {
    value: {
      type: [Object, Array],
      default: null
    },
    multiple: {
      type: Boolean,
      default: !1
    },
    placeholder: {
      type: String,
      default: "Choose an option"
    },
    searchable: {
      type: Boolean,
      default: !1
    },
    clearable: {
      type: Boolean,
      default: !0
    },
    loading: {
      type: Boolean,
      default: !1
    },
    disabled: {
      type: Boolean,
      default: !1
    }
  },
  data() {
    return {
      dropdownVisible: !1,
      focusedOptionIndex: null,
      search: null,
      visibleOptions: null
    };
  },
  computed: {
    hasValue() {
      return !!(this.multiple && this.value.length > 0 || !this.multiple && this.value);
    },
    classObject() {
      return {
        "lv-select--disabled": !!this.disabled || !!this.loading,
        "lv-select--loading": !!this.loading
      };
    }
  },
  watch: {
    search(i) {
      !this.dropdownVisible && i && (this.dropdownVisible = !0);
    },
    value(i) {
      !this.multiple && this.dropdownVisible && (this.dropdownVisible = !1), i && this.search && (this.search = null);
    }
  },
  mounted() {
    this.visibleOptions = this.getVisibleOptions(), f(this.$refs.select, () => {
      this.dropdownVisible = !1;
    });
  },
  updated() {
    this.$nextTick(() => {
      this.visibleOptions = this.getVisibleOptions();
    });
  },
  methods: {
    getVisibleOptions() {
      return this.$el.querySelectorAll(".lv-select-option").length;
    },
    onClickSelection() {
      this.dropdownVisible = !this.dropdownVisible;
    }
  }
}, L = ["aria-expanded"], z = {
  key: 0,
  class: "lv-select__value"
}, A = {
  key: 1,
  class: "lv-select__values"
}, D = ["placeholder"], E = {
  key: 3,
  class: "lv-select__placeholder"
}, K = {
  class: "lv-select__dropdown",
  role: "listbox"
}, M = {
  key: 0,
  class: "lv-select__no-options"
};
function q(i, a, e, F, n, o) {
  const u = m("lv-icon");
  return l(), s("div", {
    ref: "select",
    class: y(["lv-select", o.classObject]),
    role: "combobox",
    "aria-expanded": n.dropdownVisible,
    "aria-haspopup": "listbox"
  }, [
    h("div", {
      ref: "combobox",
      class: "lv-select__input",
      tabindex: "0",
      onClick: a[1] || (a[1] = (...t) => o.onClickSelection && o.onClickSelection(...t)),
      onKeydown: a[2] || (a[2] = V(w((...t) => o.onClickSelection && o.onClickSelection(...t), ["prevent"]), ["enter", "space"]))
    }, [
      o.hasValue && !e.multiple ? (l(), s("div", z, [
        r(i.$slots, "value", { value: e.value }, () => [
          v(c(e.value.label), 1)
        ])
      ])) : o.hasValue && e.multiple ? (l(), s("div", A, [
        (l(!0), s(k, null, g(e.value, (t, b) => (l(), s("span", {
          key: b,
          class: "lv-select__values-item"
        }, [
          r(i.$slots, "value", {
            values: e.value,
            value: t
          }, () => [
            v(c(t.label), 1)
          ])
        ]))), 128))
      ])) : e.searchable ? p((l(), s("input", {
        key: 2,
        "onUpdate:modelValue": a[0] || (a[0] = (t) => n.search = t),
        class: "lv-select__search",
        type: "text",
        placeholder: e.placeholder
      }, null, 8, D)), [
        [x, n.search]
      ]) : (l(), s("div", E, c(e.placeholder), 1)),
      e.loading ? (l(), _(u, {
        key: 4,
        class: "lv-select__loading",
        size: 16,
        name: "loader-2"
      })) : (l(), _(u, {
        key: 5,
        class: "lv-select__icon",
        name: "chevron-down"
      }))
    ], 544),
    O(C, { name: "dropdown" }, {
      default: S(() => [
        p(h("div", K, [
          r(i.$slots, "default"),
          n.visibleOptions ? B("", !0) : (l(), s("div", M, "No options found"))
        ], 512), [
          [N, n.dropdownVisible]
        ])
      ]),
      _: 3
    })
  ], 10, L);
}
const J = /* @__PURE__ */ T(j, [["render", q]]);
export {
  J as default
};
