import { resolveComponent as f, openBlock as n, createElementBlock as l, normalizeClass as T, createElementVNode as i, normalizeStyle as r, withModifiers as b, createBlock as u, Fragment as h, createTextVNode as m, toDisplayString as c } from "vue";
import { _ as p } from "./_plugin-vue_export-helper.e9cbb45e.mjs";
import { u as v } from "./index.673e51a0.mjs";
const M = {
  props: {
    min: {
      type: Number,
      default: 0
    },
    max: {
      type: Number,
      default: 100
    },
    modelValue: {
      type: Number,
      default: 0
    },
    decimals: {
      type: Number,
      default: 0,
      validator(e) {
        return e >= 0;
      }
    },
    step: {
      type: Number,
      default: 1,
      validator(e) {
        return e > 0;
      }
    },
    invalid: {
      type: Boolean,
      default: !1
    },
    disabled: {
      type: Boolean,
      default: !1
    },
    loading: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["update:modelValue"],
  data() {
    return {
      trackX: 0,
      trackWidth: 0,
      thumbPosition: 0
    };
  },
  computed: {
    classNames() {
      return {
        "lv-slider--invalid": this.invalid,
        "lv-slider--disabled": this.disabled,
        "lv-slider--loading": this.loading
      };
    },
    parsedValue() {
      const e = (this.max - this.min) / 100 * this.thumbPosition + this.min;
      return parseFloat(e.toFixed(this.decimals));
    },
    indicatorRight() {
      return this.thumbPosition;
    },
    stepPercentage() {
      return 100 / (this.max - this.min) * this.step;
    }
  },
  watch: {
    modelValue: {
      handler(e) {
        this.thumbPosition = e ? this.getPositionFromValue(e) : 100;
      },
      deep: !0,
      immediate: !0
    }
  },
  mounted() {
    this.cacheDimensions();
  },
  created() {
    this.onThumbMouseMoveThrottled = v(this.onThumbMouseMove, 25, !1), this.onThumbTouchMoveThrottled = v(this.onThumbTouchMove, 25, !1);
  },
  methods: {
    onThumbMouseDown() {
      this.disabled || this.loading || (this.cacheDimensions(), document.addEventListener("mousemove", this.onThumbMouseMoveThrottled, !1), document.addEventListener("mouseup", this.onMouseUp, !1));
    },
    onThumbMouseMove(e) {
      this.thumbPosition = this.getRelativePosition(e.pageX);
    },
    onMouseUp() {
      document.removeEventListener("mousemove", this.onThumbMouseMoveThrottled, !1), document.removeEventListener("mouseup", this.onMouseUp, !1), this.emitInputEvent();
    },
    onThumbTouchStart() {
      this.disabled || (this.cacheDimensions(), document.addEventListener("touchmove", this.onThumbTouchMoveThrottled), document.addEventListener("touchend", this.onTouchEnd));
    },
    onThumbTouchMove(e) {
      e.preventDefault(), this.thumbPosition = this.getRelativePosition(e.touches[0].clientX);
    },
    onTouchEnd() {
      document.removeEventListener("touchmove", this.onThumbTouchMoveThrottled), document.removeEventListener("touchend", this.onTouchEnd), this.emitInputEvent();
    },
    emitInputEvent() {
      this.$emit("update:modelValue", this.parsedValue);
    },
    cacheDimensions() {
      this.trackWidth = this.$refs.track.offsetWidth, this.trackX = this.$refs.track.getBoundingClientRect().left;
    },
    getPositionFromValue(e) {
      return 100 / (this.max - this.min) * e - this.min / (this.max - this.min) * 100;
    },
    getRelativePosition(e) {
      let t = (e - this.trackX) / this.trackWidth * 100;
      return this.step && (t = Math.round(t / this.stepPercentage) * this.stepPercentage), t = Math.min(Math.max(t, 0), 100), t;
    }
  }
}, g = { class: "lv-slider__track" }, y = {
  ref: "track",
  class: "lv-slider__track-limits"
}, k = { class: "lv-slider__amounts" }, E = { class: "lv-slider__amount lv-slider__amount--primary" }, x = { class: "lv-slider__amount lv-slider__amount--secondary" };
function P(e, o, t, L, _, s) {
  const d = f("lv-icon");
  return n(), l("div", {
    class: T(["lv-slider", s.classNames])
  }, [
    i("div", g, [
      i("div", y, [
        i("div", {
          class: "lv-slider__indicator",
          style: r({ left: 0, right: 100 - s.indicatorRight + "%" })
        }, null, 4),
        i("div", {
          class: "lv-slider__thumb lv-slider__thumb",
          style: r({ left: _.thumbPosition + "%" }),
          onMousedown: o[0] || (o[0] = b((...a) => s.onThumbMouseDown && s.onThumbMouseDown(...a), ["prevent"])),
          onTouchstart: o[1] || (o[1] = (...a) => s.onThumbTouchStart && s.onThumbTouchStart(...a))
        }, null, 36)
      ], 512)
    ]),
    i("div", k, [
      i("div", E, [
        t.loading ? (n(), u(d, {
          key: 0,
          class: "lv-slider__loader",
          size: 12,
          name: "loader-2"
        })) : (n(), l(h, { key: 1 }, [
          m(c(t.min.toFixed(t.decimals)), 1)
        ], 64))
      ]),
      i("div", x, [
        t.loading ? (n(), u(d, {
          key: 0,
          class: "lv-slider__loader",
          size: 12,
          name: "loader-2"
        })) : (n(), l(h, { key: 1 }, [
          m(c(t.max.toFixed(t.decimals)), 1)
        ], 64))
      ])
    ])
  ], 2);
}
const F = /* @__PURE__ */ p(M, [["render", P]]);
export {
  F as default
};
